require "httparty"
require "delegate"
require "recursive-open-struct"

require "wirecard_subscriptions/version"

require "wirecard_subscriptions/authentication/basic"

require "wirecard_subscriptions/resources/plan"

require "wirecard_subscriptions/response"
require "wirecard_subscriptions/client"
require "wirecard_subscriptions/api"
require "wirecard_subscriptions/plan_api"

require "wirecard_subscriptions/exceptions/invalid_enviroment_error"

module WirecardSubscriptions
  class << self
    VALID_ENVS = %i(sandbox production).freeze

    def env=(env)
      raise InvalidEnviromentError unless VALID_ENVS.include?(env.to_sym)
      @env = env
    end

    def env
      @env ||= :sandbox
    end

    def auth=(credentials)
      @credentials = credentials
    end

    def auth
      @credentials
    end

    def opts=(opts = {})
      @opts = opts
    end

    def opts
      @opts ||= {}
    end

    def new
      raise "Auth is not set" unless auth

      Api.new Client.new(env, auth)
    end
  end

  class NotFoundError < StandardError
  end
end
